> For the complete documentation index, see [llms.txt](https://docs.degirum.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.degirum.com/pysdk/readme.md).

# Overview

DeGirum PySDK is a Python library designed to make AI development and deployment simple and efficient. With PySDK, we aim to provide APIs with a very low barrier to entry for AI model inferencing while ensuring maximum performance. It is engineered for optimal pipelining and hardware acceleration across CPUs, GPUs, NPUs, and AI accelerators.

Our goal is to provide a consistent API so your code can target multiple supported runtimes and devices without changing application logic. PySDK integrates with DeGirum AI Hub, eliminating the need for manual model downloads. Whether you're running AI locally, on an AI server, or using hardware hosted in our AI Hub, the same PySDK code works across all environments.

## Why Developers Use PySDK

<table data-view="cards"><thead><tr><th></th><th></th><th data-hidden data-card-cover data-type="image">Cover image</th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>Simple and Efficient APIs</strong></td><td>See how easy it is to get started with PySDK</td><td data-object-fit="cover"><a href="/files/oqAQOf5QR7aGbqoryCuT">/files/oqAQOf5QR7aGbqoryCuT</a></td><td><a href="/pages/MWsZ4rk1sJhxeDPmJww3">/pages/MWsZ4rk1sJhxeDPmJww3</a></td></tr><tr><td><strong>Support for Multiple Hardware</strong></td><td>Unlock access to AI hardware</td><td data-object-fit="cover"><a href="/files/Lr8Kxz9HXTM8RcEYIkYV">/files/Lr8Kxz9HXTM8RcEYIkYV</a></td><td><a href="/pages/Kcs9VG2k5sSJrh9ZRL4A">/pages/Kcs9VG2k5sSJrh9ZRL4A</a></td></tr><tr><td><strong>Integration with AI Hub</strong></td><td>Get started on DeGirum AI Hub</td><td data-object-fit="cover"><a href="/files/gakYoOy5KRULpSF4K7cO">/files/gakYoOy5KRULpSF4K7cO</a></td><td><a href="https://hub.degirum.com/?utm_source=docs.degirum.com&#x26;utm_medium=site&#x26;utm_campaign=pysdk-overview">https://hub.degirum.com/?utm_source=docs.degirum.com&#x26;utm_medium=site&#x26;utm_campaign=pysdk-overview</a></td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.degirum.com/pysdk/readme.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
